
_Set_up:

;fuente_lineal_DAC_2.c,31 :: 		void Set_up() {
;fuente_lineal_DAC_2.c,33 :: 		ANSEL = 0;
	CLRF       ANSEL+0
;fuente_lineal_DAC_2.c,34 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;fuente_lineal_DAC_2.c,35 :: 		C1ON_bit = 0;    // Analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;fuente_lineal_DAC_2.c,36 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;fuente_lineal_DAC_2.c,37 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;fuente_lineal_DAC_2.c,38 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;fuente_lineal_DAC_2.c,39 :: 		TRISD0_bit=0;
	BCF        TRISD0_bit+0, BitPos(TRISD0_bit+0)
;fuente_lineal_DAC_2.c,40 :: 		TRISD1_bit=0;
	BCF        TRISD1_bit+0, BitPos(TRISD1_bit+0)
;fuente_lineal_DAC_2.c,41 :: 		Keypad_Init();
	CALL       _Keypad_Init+0
;fuente_lineal_DAC_2.c,42 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;fuente_lineal_DAC_2.c,43 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;fuente_lineal_DAC_2.c,44 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;fuente_lineal_DAC_2.c,45 :: 		Chip_Select = 1;                       // Deselect DAC
	BSF        RC0_bit+0, BitPos(RC0_bit+0)
;fuente_lineal_DAC_2.c,46 :: 		Chip_Select_Direction = 0;             // Set CS# pin as Output
	BCF        TRISC0_bit+0, BitPos(TRISC0_bit+0)
;fuente_lineal_DAC_2.c,47 :: 		SPI1_Init();                           // Initialize SPI module
	CALL       _SPI1_Init+0
;fuente_lineal_DAC_2.c,48 :: 		RD0_bit=0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;fuente_lineal_DAC_2.c,49 :: 		RD1_bit=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;fuente_lineal_DAC_2.c,50 :: 		text = "Voltaje_pedido:";
	MOVLW      ?lstr1_fuente_lineal_DAC_2+0
	MOVWF      _text+0
;fuente_lineal_DAC_2.c,51 :: 		Lcd_Out(1,1,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;fuente_lineal_DAC_2.c,52 :: 		}
L_end_Set_up:
	RETURN
; end of _Set_up

_buzzer:

;fuente_lineal_DAC_2.c,54 :: 		void buzzer() {
;fuente_lineal_DAC_2.c,55 :: 		RD1_bit=1;
	BSF        RD1_bit+0, BitPos(RD1_bit+0)
;fuente_lineal_DAC_2.c,56 :: 		delay_ms(Tone);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_buzzer0:
	DECFSZ     R13+0, 1
	GOTO       L_buzzer0
	DECFSZ     R12+0, 1
	GOTO       L_buzzer0
	DECFSZ     R11+0, 1
	GOTO       L_buzzer0
	NOP
;fuente_lineal_DAC_2.c,57 :: 		RD1_bit=0;
	BCF        RD1_bit+0, BitPos(RD1_bit+0)
;fuente_lineal_DAC_2.c,58 :: 		delay_ms(Tone);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_buzzer1:
	DECFSZ     R13+0, 1
	GOTO       L_buzzer1
	DECFSZ     R12+0, 1
	GOTO       L_buzzer1
	DECFSZ     R11+0, 1
	GOTO       L_buzzer1
	NOP
;fuente_lineal_DAC_2.c,59 :: 		}
L_end_buzzer:
	RETURN
; end of _buzzer

_DAC_Output:

;fuente_lineal_DAC_2.c,62 :: 		void DAC_Output(unsigned int valueDAC) {
;fuente_lineal_DAC_2.c,65 :: 		Chip_Select = 0;                       // Select DAC chip
	BCF        RC0_bit+0, BitPos(RC0_bit+0)
;fuente_lineal_DAC_2.c,68 :: 		temp = (valueDAC >> 8) & 0x0F;         // Store valueDAC[11..8] to temp[3..0]
	MOVF       FARG_DAC_Output_valueDAC+1, 0
	MOVWF      R0+0
	CLRF       R0+1
	MOVLW      15
	ANDWF      R0+0, 0
	MOVWF      FARG_SPI1_Write_data_+0
;fuente_lineal_DAC_2.c,69 :: 		temp |= 0x30;                     // Define DAC setting, see MCP4921 datasheet
	MOVLW      48
	IORWF      FARG_SPI1_Write_data_+0, 1
;fuente_lineal_DAC_2.c,70 :: 		SPI1_Write(temp);                 // Send high byte via SPI
	CALL       _SPI1_Write+0
;fuente_lineal_DAC_2.c,74 :: 		SPI1_Write(temp);                      // Send low byte via SPI
	MOVF       FARG_DAC_Output_valueDAC+0, 0
	MOVWF      FARG_SPI1_Write_data_+0
	CALL       _SPI1_Write+0
;fuente_lineal_DAC_2.c,76 :: 		Chip_Select = 1;                       // Deselect DAC chip
	BSF        RC0_bit+0, BitPos(RC0_bit+0)
;fuente_lineal_DAC_2.c,77 :: 		}
L_end_DAC_Output:
	RETURN
; end of _DAC_Output

_Voltage:

;fuente_lineal_DAC_2.c,79 :: 		void Voltage() {
;fuente_lineal_DAC_2.c,83 :: 		ch = voltaje/1000;
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _voltaje+0, 0
	MOVWF      R0+0
	MOVF       _voltaje+1, 0
	MOVWF      R0+1
	MOVF       _voltaje+2, 0
	MOVWF      R0+2
	MOVF       _voltaje+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
;fuente_lineal_DAC_2.c,84 :: 		Lcd_Chr(2,5,48+ch);
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      5
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;fuente_lineal_DAC_2.c,85 :: 		ch = (voltaje / 100 )% 10;
	MOVLW      100
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _voltaje+0, 0
	MOVWF      R0+0
	MOVF       _voltaje+1, 0
	MOVWF      R0+1
	MOVF       _voltaje+2, 0
	MOVWF      R0+2
	MOVF       _voltaje+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;fuente_lineal_DAC_2.c,86 :: 		Lcd_Chr_CP(48+ch);
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;fuente_lineal_DAC_2.c,87 :: 		Lcd_Chr(2,7,'.');
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      46
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;fuente_lineal_DAC_2.c,88 :: 		ch = (voltaje / 10 )% 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _voltaje+0, 0
	MOVWF      R0+0
	MOVF       _voltaje+1, 0
	MOVWF      R0+1
	MOVF       _voltaje+2, 0
	MOVWF      R0+2
	MOVF       _voltaje+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;fuente_lineal_DAC_2.c,89 :: 		Lcd_Chr(2,8,48+ch);
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      8
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;fuente_lineal_DAC_2.c,90 :: 		ch = voltaje % 10;
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _voltaje+0, 0
	MOVWF      R0+0
	MOVF       _voltaje+1, 0
	MOVWF      R0+1
	MOVF       _voltaje+2, 0
	MOVWF      R0+2
	MOVF       _voltaje+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
;fuente_lineal_DAC_2.c,91 :: 		Lcd_Chr_CP(48+ch);
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;fuente_lineal_DAC_2.c,92 :: 		}
L_end_Voltage:
	RETURN
; end of _Voltage

_keypad:

;fuente_lineal_DAC_2.c,94 :: 		void keypad() {
;fuente_lineal_DAC_2.c,95 :: 		short int i=0, select=0;
	CLRF       keypad_i_L0+0
	CLRF       keypad_select_L0+0
;fuente_lineal_DAC_2.c,96 :: 		RD0_bit=1;
	BSF        RD0_bit+0, BitPos(RD0_bit+0)
;fuente_lineal_DAC_2.c,97 :: 		buzzer();
	CALL       _buzzer+0
;fuente_lineal_DAC_2.c,98 :: 		for(i=0; i<=3; i++){
	CLRF       keypad_i_L0+0
L_keypad2:
	MOVLW      128
	XORLW      3
	MOVWF      R0+0
	MOVLW      128
	XORWF      keypad_i_L0+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_keypad3
;fuente_lineal_DAC_2.c,99 :: 		voltaje =(10*voltaje) + contador;
	MOVLW      10
	MOVWF      R0+0
	CLRF       R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVF       _voltaje+0, 0
	MOVWF      R4+0
	MOVF       _voltaje+1, 0
	MOVWF      R4+1
	MOVF       _voltaje+2, 0
	MOVWF      R4+2
	MOVF       _voltaje+3, 0
	MOVWF      R4+3
	CALL       _Mul_32x32_U+0
	MOVF       _contador+0, 0
	MOVWF      R4+0
	MOVLW      0
	BTFSC      R4+0, 7
	MOVLW      255
	MOVWF      R4+1
	MOVWF      R4+2
	MOVWF      R4+3
	MOVF       R0+0, 0
	ADDWF      R4+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+1, 0
	ADDWF      R4+1, 1
	MOVF       R0+2, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+2, 0
	ADDWF      R4+2, 1
	MOVF       R0+3, 0
	BTFSC      STATUS+0, 0
	INCFSZ     R0+3, 0
	ADDWF      R4+3, 1
	MOVF       R4+0, 0
	MOVWF      _voltaje+0
	MOVF       R4+1, 0
	MOVWF      _voltaje+1
	MOVF       R4+2, 0
	MOVWF      _voltaje+2
	MOVF       R4+3, 0
	MOVWF      _voltaje+3
;fuente_lineal_DAC_2.c,100 :: 		if(voltaje>1630) voltaje=contador;
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R4+3, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__keypad44
	MOVF       R4+2, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__keypad44
	MOVF       R4+1, 0
	SUBLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__keypad44
	MOVF       R4+0, 0
	SUBLW      94
L__keypad44:
	BTFSC      STATUS+0, 0
	GOTO       L_keypad5
	MOVF       _contador+0, 0
	MOVWF      _voltaje+0
	MOVLW      0
	BTFSC      _voltaje+0, 7
	MOVLW      255
	MOVWF      _voltaje+1
	MOVWF      _voltaje+2
	MOVWF      _voltaje+3
L_keypad5:
;fuente_lineal_DAC_2.c,101 :: 		volt=voltaje/0.398046; // vref=1.63 or aprox resolution = 1000*(Vref/4095)
	MOVF       _voltaje+0, 0
	MOVWF      R0+0
	MOVF       _voltaje+1, 0
	MOVWF      R0+1
	MOVF       _voltaje+2, 0
	MOVWF      R0+2
	MOVF       _voltaje+3, 0
	MOVWF      R0+3
	CALL       _longint2double+0
	MOVLW      175
	MOVWF      R4+0
	MOVLW      204
	MOVWF      R4+1
	MOVLW      75
	MOVWF      R4+2
	MOVLW      125
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _volt+0
	MOVF       R0+1, 0
	MOVWF      _volt+1
	MOVF       R0+2, 0
	MOVWF      _volt+2
	MOVF       R0+3, 0
	MOVWF      _volt+3
;fuente_lineal_DAC_2.c,102 :: 		if(volt<22) volt=22;
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      48
	MOVWF      R4+2
	MOVLW      131
	MOVWF      R4+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_keypad6
	MOVLW      0
	MOVWF      _volt+0
	MOVLW      0
	MOVWF      _volt+1
	MOVLW      48
	MOVWF      _volt+2
	MOVLW      131
	MOVWF      _volt+3
L_keypad6:
;fuente_lineal_DAC_2.c,103 :: 		Voltage();
	CALL       _Voltage+0
;fuente_lineal_DAC_2.c,104 :: 		do //wait that the keypad is pressed and after that is free.
L_keypad7:
;fuente_lineal_DAC_2.c,105 :: 		kp=Keypad_Key_Click();  //read the keypad.
	CALL       _Keypad_Key_Click+0
	MOVF       R0+0, 0
	MOVWF      _kp+0
;fuente_lineal_DAC_2.c,106 :: 		while (!kp);
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_keypad7
;fuente_lineal_DAC_2.c,108 :: 		if(kp==1)  contador = 1;
	MOVF       _kp+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_keypad10
	MOVLW      1
	MOVWF      _contador+0
L_keypad10:
;fuente_lineal_DAC_2.c,109 :: 		if(kp==2)  contador = 2;
	MOVF       _kp+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_keypad11
	MOVLW      2
	MOVWF      _contador+0
L_keypad11:
;fuente_lineal_DAC_2.c,110 :: 		if(kp==3)  contador = 3;
	MOVF       _kp+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_keypad12
	MOVLW      3
	MOVWF      _contador+0
L_keypad12:
;fuente_lineal_DAC_2.c,111 :: 		if(kp==5)  contador = 4;
	MOVF       _kp+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L_keypad13
	MOVLW      4
	MOVWF      _contador+0
L_keypad13:
;fuente_lineal_DAC_2.c,112 :: 		if(kp==6)  contador = 5;
	MOVF       _kp+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L_keypad14
	MOVLW      5
	MOVWF      _contador+0
L_keypad14:
;fuente_lineal_DAC_2.c,113 :: 		if(kp==7)  contador = 6;
	MOVF       _kp+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L_keypad15
	MOVLW      6
	MOVWF      _contador+0
L_keypad15:
;fuente_lineal_DAC_2.c,114 :: 		if(Kp==9)  contador = 7;
	MOVF       _kp+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L_keypad16
	MOVLW      7
	MOVWF      _contador+0
L_keypad16:
;fuente_lineal_DAC_2.c,115 :: 		if(kp==10) contador = 8;
	MOVF       _kp+0, 0
	XORLW      10
	BTFSS      STATUS+0, 2
	GOTO       L_keypad17
	MOVLW      8
	MOVWF      _contador+0
L_keypad17:
;fuente_lineal_DAC_2.c,116 :: 		if(kp==11) contador = 9;
	MOVF       _kp+0, 0
	XORLW      11
	BTFSS      STATUS+0, 2
	GOTO       L_keypad18
	MOVLW      9
	MOVWF      _contador+0
L_keypad18:
;fuente_lineal_DAC_2.c,117 :: 		if(kp==13) contador = 0, voltaje=0, i=0; //clear(*)
	MOVF       _kp+0, 0
	XORLW      13
	BTFSS      STATUS+0, 2
	GOTO       L_keypad19
	CLRF       _contador+0
	CLRF       _voltaje+0
	CLRF       _voltaje+1
	CLRF       _voltaje+2
	CLRF       _voltaje+3
	CLRF       keypad_i_L0+0
L_keypad19:
;fuente_lineal_DAC_2.c,118 :: 		if(kp==14) contador = 0;
	MOVF       _kp+0, 0
	XORLW      14
	BTFSS      STATUS+0, 2
	GOTO       L_keypad20
	CLRF       _contador+0
L_keypad20:
;fuente_lineal_DAC_2.c,119 :: 		if(kp==15) contador = 0, select=1; //Enter(#)
	MOVF       _kp+0, 0
	XORLW      15
	BTFSS      STATUS+0, 2
	GOTO       L_keypad21
	CLRF       _contador+0
	MOVLW      1
	MOVWF      keypad_select_L0+0
L_keypad21:
;fuente_lineal_DAC_2.c,120 :: 		kp=0;
	CLRF       _kp+0
;fuente_lineal_DAC_2.c,121 :: 		if((select==0)&&(i==3)) i=0;
	MOVF       keypad_select_L0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_keypad24
	MOVF       keypad_i_L0+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_keypad24
L__keypad38:
	CLRF       keypad_i_L0+0
L_keypad24:
;fuente_lineal_DAC_2.c,122 :: 		if(select==1) i=3;
	MOVF       keypad_select_L0+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_keypad25
	MOVLW      3
	MOVWF      keypad_i_L0+0
L_keypad25:
;fuente_lineal_DAC_2.c,123 :: 		buzzer();
	CALL       _buzzer+0
;fuente_lineal_DAC_2.c,98 :: 		for(i=0; i<=3; i++){
	INCF       keypad_i_L0+0, 1
;fuente_lineal_DAC_2.c,124 :: 		}
	GOTO       L_keypad2
L_keypad3:
;fuente_lineal_DAC_2.c,125 :: 		}
L_end_keypad:
	RETURN
; end of _keypad

_main:

;fuente_lineal_DAC_2.c,127 :: 		void main() {
;fuente_lineal_DAC_2.c,128 :: 		Set_up();   // Perform main initialization
	CALL       _Set_up+0
;fuente_lineal_DAC_2.c,129 :: 		keypad();
	CALL       _keypad+0
;fuente_lineal_DAC_2.c,131 :: 		while (1) {
L_main26:
;fuente_lineal_DAC_2.c,132 :: 		RD0_bit=0;
	BCF        RD0_bit+0, BitPos(RD0_bit+0)
;fuente_lineal_DAC_2.c,133 :: 		if(Keypad_Key_press()) delay_ms(100), voltaje=0, keypad();
	CALL       _Keypad_Key_Press+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main28
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L_main29:
	DECFSZ     R13+0, 1
	GOTO       L_main29
	DECFSZ     R12+0, 1
	GOTO       L_main29
	DECFSZ     R11+0, 1
	GOTO       L_main29
	NOP
	CLRF       _voltaje+0
	CLRF       _voltaje+1
	CLRF       _voltaje+2
	CLRF       _voltaje+3
	CALL       _keypad+0
L_main28:
;fuente_lineal_DAC_2.c,135 :: 		for(retardo=retardo; retardo<=volt; retardo++){
L_main30:
	MOVF       _retardo+0, 0
	MOVWF      R0+0
	MOVF       _retardo+1, 0
	MOVWF      R0+1
	MOVF       _retardo+2, 0
	MOVWF      R0+2
	MOVF       _retardo+3, 0
	MOVWF      R0+3
	CALL       _longint2double+0
	MOVF       R0+0, 0
	MOVWF      R4+0
	MOVF       R0+1, 0
	MOVWF      R4+1
	MOVF       R0+2, 0
	MOVWF      R4+2
	MOVF       R0+3, 0
	MOVWF      R4+3
	MOVF       _volt+0, 0
	MOVWF      R0+0
	MOVF       _volt+1, 0
	MOVWF      R0+1
	MOVF       _volt+2, 0
	MOVWF      R0+2
	MOVF       _volt+3, 0
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main31
;fuente_lineal_DAC_2.c,136 :: 		DAC_Output(retardo);                   // Send value to DAC chip
	MOVF       _retardo+0, 0
	MOVWF      FARG_DAC_Output_valueDAC+0
	MOVF       _retardo+1, 0
	MOVWF      FARG_DAC_Output_valueDAC+1
	CALL       _DAC_Output+0
;fuente_lineal_DAC_2.c,137 :: 		Delay_ms(20);                         // Slow down key repeat pace
	MOVLW      52
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_main33:
	DECFSZ     R13+0, 1
	GOTO       L_main33
	DECFSZ     R12+0, 1
	GOTO       L_main33
	NOP
	NOP
;fuente_lineal_DAC_2.c,135 :: 		for(retardo=retardo; retardo<=volt; retardo++){
	MOVF       _retardo+0, 0
	MOVWF      R0+0
	MOVF       _retardo+1, 0
	MOVWF      R0+1
	MOVF       _retardo+2, 0
	MOVWF      R0+2
	MOVF       _retardo+3, 0
	MOVWF      R0+3
	INCF       R0+0, 1
	BTFSC      STATUS+0, 2
	INCF       R0+1, 1
	BTFSC      STATUS+0, 2
	INCF       R0+2, 1
	BTFSC      STATUS+0, 2
	INCF       R0+3, 1
	MOVF       R0+0, 0
	MOVWF      _retardo+0
	MOVF       R0+1, 0
	MOVWF      _retardo+1
	MOVF       R0+2, 0
	MOVWF      _retardo+2
	MOVF       R0+3, 0
	MOVWF      _retardo+3
;fuente_lineal_DAC_2.c,138 :: 		}
	GOTO       L_main30
L_main31:
;fuente_lineal_DAC_2.c,139 :: 		for(retardo=retardo; retardo>=volt; retardo--){
L_main34:
	MOVF       _retardo+0, 0
	MOVWF      R0+0
	MOVF       _retardo+1, 0
	MOVWF      R0+1
	MOVF       _retardo+2, 0
	MOVWF      R0+2
	MOVF       _retardo+3, 0
	MOVWF      R0+3
	CALL       _longint2double+0
	MOVF       _volt+0, 0
	MOVWF      R4+0
	MOVF       _volt+1, 0
	MOVWF      R4+1
	MOVF       _volt+2, 0
	MOVWF      R4+2
	MOVF       _volt+3, 0
	MOVWF      R4+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main35
;fuente_lineal_DAC_2.c,140 :: 		DAC_Output(retardo);                   // Send value to DAC chip
	MOVF       _retardo+0, 0
	MOVWF      FARG_DAC_Output_valueDAC+0
	MOVF       _retardo+1, 0
	MOVWF      FARG_DAC_Output_valueDAC+1
	CALL       _DAC_Output+0
;fuente_lineal_DAC_2.c,141 :: 		Delay_ms(20);                         // Slow down key repeat pace
	MOVLW      52
	MOVWF      R12+0
	MOVLW      241
	MOVWF      R13+0
L_main37:
	DECFSZ     R13+0, 1
	GOTO       L_main37
	DECFSZ     R12+0, 1
	GOTO       L_main37
	NOP
	NOP
;fuente_lineal_DAC_2.c,139 :: 		for(retardo=retardo; retardo>=volt; retardo--){
	MOVLW      1
	SUBWF      _retardo+0, 1
	BTFSS      STATUS+0, 0
	SUBWF      _retardo+1, 1
	BTFSS      STATUS+0, 0
	SUBWF      _retardo+2, 1
	BTFSS      STATUS+0, 0
	SUBWF      _retardo+3, 1
;fuente_lineal_DAC_2.c,142 :: 		}
	GOTO       L_main34
L_main35:
;fuente_lineal_DAC_2.c,143 :: 		}
	GOTO       L_main26
;fuente_lineal_DAC_2.c,144 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
