#line 1 "C:/Users/Usuario/Documents/Voltaje_sources_with MCP4921/PIC16F887/fuente_lineal_DAC_2.c"






sbit Chip_Select at RC0_bit;
sbit Chip_Select_Direction at TRISC0_bit;

extern sfr char keypadPort;
char keypadPort at PORTB;

sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;

char *text, kp=0;
int short contador=0;
long voltaje=0, retardo=0;
float volt;

void Set_up() {

 ANSEL = 0;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 CCP1CON = 0;
 CCP2CON = 0;
 TRISD0_bit=0;
 TRISD1_bit=0;
 Keypad_Init();
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Chip_Select = 1;
 Chip_Select_Direction = 0;
 SPI1_Init();
 RD0_bit=0;
 RD1_bit=0;
 text = "Voltaje_pedido:";
 Lcd_Out(1,1,text);
}

void buzzer() {
 RD1_bit=1;
 delay_ms( 100 );
 RD1_bit=0;
 delay_ms( 100 );
}


void DAC_Output(unsigned int valueDAC) {
 char temp;

 Chip_Select = 0;


 temp = (valueDAC >> 8) & 0x0F;
 temp |= 0x30;
 SPI1_Write(temp);


 temp = valueDAC;
 SPI1_Write(temp);

 Chip_Select = 1;
}

void Voltage() {

 unsigned char ch ;

 ch = voltaje/1000;
 Lcd_Chr(2,5,48+ch);
 ch = (voltaje / 100 )% 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(2,7,'.');
 ch = (voltaje / 10 )% 10;
 Lcd_Chr(2,8,48+ch);
 ch = voltaje % 10;
 Lcd_Chr_CP(48+ch);
}

void keypad() {
 short int i=0, select=0;
 RD0_bit=1;
 buzzer();
for(i=0; i<=3; i++){
 voltaje =(10*voltaje) + contador;
 if(voltaje>1630) voltaje=contador;
 volt=voltaje/0.398046;
 if(volt<22) volt=22;
 Voltage();
 do
 kp=Keypad_Key_Click();
 while (!kp);

 if(kp==1) contador = 1;
 if(kp==2) contador = 2;
 if(kp==3) contador = 3;
 if(kp==5) contador = 4;
 if(kp==6) contador = 5;
 if(kp==7) contador = 6;
 if(Kp==9) contador = 7;
 if(kp==10) contador = 8;
 if(kp==11) contador = 9;
 if(kp==13) contador = 0, voltaje=0, i=0;
 if(kp==14) contador = 0;
 if(kp==15) contador = 0, select=1;
 kp=0;
 if((select==0)&&(i==3)) i=0;
 if(select==1) i=3;
 buzzer();
 }
}

void main() {
 Set_up();
 keypad();

 while (1) {
 RD0_bit=0;
 if(Keypad_Key_press()) delay_ms(100), voltaje=0, keypad();

 for(retardo=retardo; retardo<=volt; retardo++){
 DAC_Output(retardo);
 Delay_ms(20);
 }
 for(retardo=retardo; retardo>=volt; retardo--){
 DAC_Output(retardo);
 Delay_ms(20);
 }
 }
 }
