#line 1 "C:/Users/Usuario/Documents/Voltaje_sources_with MCP4921/ATMEGA16/Voltage_source_with_MCP4921.c"
#line 17 "C:/Users/Usuario/Documents/Voltaje_sources_with MCP4921/ATMEGA16/Voltage_source_with_MCP4921.c"
sbit Chip_Select at PORTB0_bit;
sbit Chip_Select_Direction at DDB0_bit;



sbit LCD_RS at PORTC2_bit;
sbit LCD_EN at PORTC3_bit;
sbit LCD_D4 at PORTC4_bit;
sbit LCD_D5 at PORTC5_bit;
sbit LCD_D6 at PORTC6_bit;
sbit LCD_D7 at PORTC7_bit;

sbit LCD_RS_Direction at DDC2_bit;
sbit LCD_EN_Direction at DDC3_bit;
sbit LCD_D4_Direction at DDC4_bit;
sbit LCD_D5_Direction at DDC5_bit;
sbit LCD_D6_Direction at DDC6_bit;
sbit LCD_D7_Direction at DDC7_bit;



long Voltio=0, Vint=0, retardo=0;
int short contador=0, aux=0;
float value;
char *text;

void buzzer() {
 PORTC.b1 = 1;
 delay_ms( 150 );
 PORTC.b1 = 0;
 delay_ms( 150 );
}

void DAC_Output(unsigned int valueDAC) {
 char volt;

 Chip_Select = 0;


 volt = (valueDAC >> 8) & 0x0F;
 volt |= 0x30;
 SPI1_Write(volt);


 volt = valueDAC;
 SPI1_Write(volt);

 Chip_Select = 1;
}


DIG_OR_DEC() {
 buzzer();
 if(aux==3) Vint = voltio;
 else Vint = value;

 for(retardo=retardo; retardo<=Vint; retardo++){
 DAC_Output(retardo);
 Delay_ms(20);
 }
 for(retardo=retardo; retardo>=Vint; retardo--){
 DAC_Output(retardo);
 Delay_ms(20);
 }
}



void print1(){
 unsigned char ch ;
 text = "DEC";
 Lcd_Out(2,1,text);

 ch = voltio/1000;
 Lcd_Chr(2,5,48+ch);
 ch = (voltio/ 100 )% 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(2,7,'.');
 ch = (voltio / 10 )% 10;
 Lcd_Chr(2,8,48+ch);
 ch = voltio % 10;
 Lcd_Chr_CP(48+ch);

}

void print2(){
 unsigned char ch ;
 text = "DIG";
 Lcd_Out(2,1,text);

 ch = voltio/1000;
 Lcd_Chr(2,5,48+ch);
 ch = (voltio/ 100 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = (voltio / 10 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = voltio % 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(2,9,' ');

}

void Voltage() {

 buzzer();

 if(aux==3) {
 Voltio=(10*Voltio) + contador;
 if(Voltio>4095) Voltio=contador;
 print2();
 }
 if(aux==0) {
 Voltio=(10*Voltio) + contador;
 if(Voltio>1630) Voltio=contador;
 print1();
 }
 if(aux==1) {
 Voltio=Voltio-100;
 if(Voltio<0) Voltio=0;
 print1();
 }
 if(aux==2) {
 Voltio=Voltio+100;
 if(Voltio>1630) Voltio=0;
 print1();
 }
 value=Voltio/0.398046;
 }

void set_up()
{
 DDRD = 0xF0;
 PORTD = 0x0F;
 DDC1_bit=1;
 PORTC.b1 = 0;
 Chip_Select = 1;
 Chip_Select_Direction = 1;
 SPI1_Init();
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
}
void Main()
{
 set_up();
 text = "Voltaje_INT:";
 Lcd_Out(1,2,text);
 buzzer();

 while (1)
 {




 PORTD = 0xEF;
 Delay_ms(50);
 if (!(PIND & 0x01)) contador=7, Voltage();
 if (!(PIND & 0x02)) contador=4, Voltage();
 if (!(PIND & 0x04)) contador=1, Voltage();
 if (!(PIND & 0x08)) aux=3, Voltage();


 PORTD =0xDF;
 Delay_ms(50);
 if (!(PIND & 0x01)) contador=8, Voltage();
 if (!(PIND & 0x02)) contador=5, Voltage();
 if (!(PIND & 0x04)) contador=2, Voltage();
 if (!(PIND & 0x08)) contador=0, Voltage();


 PORTD = 0xBF;
 Delay_ms(50);
 if (!(PIND & 0x01)) contador=9, Voltage();
 if (!(PIND & 0x02)) contador=6, Voltage();
 if (!(PIND & 0x04)) contador=3, Voltage();
 if (!(PIND & 0x08)) DIG_OR_DEC();


 PORTD = 0x7F;
 Delay_ms(50);
 if (!(PIND & 0x01)) contador=0, Voltio=0, Voltage();
 if (!(PIND & 0x02)) aux=0, contador=0, Voltio=0, Voltage();
 if (!(PIND & 0x04)) aux=1, contador=0, Voltage();
 if (!(PIND & 0x08)) aux=2, contador=0, Voltage();
 }
}
